CREATE TABLE Teste(
  Codigo INTEGER NOT NULL,
  Nome   VARCHAR(40) NOT NULL,
  CONSTRAINT PK_Teste PRIMARY KEY(Codigo));

SET TERM ^ ;

CREATE TRIGGER TRIG_TesteBefIns FOR Teste BEFORE INSERT AS
DECLARE VARIABLE Temp SMALLINT;
BEGIN
  Temp = WriteDebug('INSERT em Teste'); 
END^

CREATE TRIGGER TRIG_TesteBefUpd FOR Teste BEFORE UPDATE AS
DECLARE VARIABLE Temp SMALLINT;
BEGIN
  Temp = WriteDebug('UPDATE em Teste'); 
END^

CREATE TRIGGER TRIG_TesteBefDel FOR Teste BEFORE DELETE AS
DECLARE VARIABLE Temp SMALLINT;
BEGIN
  Temp = WriteDebug('DELETE em Teste'); 
END^

CREATE PROCEDURE PROC_Lista RETURNS(Nome VARCHAR(40)) AS
DECLARE VARIABLE Temp SMALLINT;
BEGIN
  Temp = WriteDebug('PROC_Lista: Iniciando');
  FOR
    SELECT Nome FROM Teste INTO :Nome
  DO
  BEGIN
    SUSPEND;
    Temp = WriteDebug('PROC_Lista: SUSPEND executado');
  END
  Temp = WriteDebug('PROC_Lista: finalizando');
END^


